
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

static struct static_route *this_srt;



/* Line 189 of yacc.c  */
#line 236 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     GEQ = 261,
     LEQ = 262,
     NEQ = 263,
     AND = 264,
     OR = 265,
     PO = 266,
     PC = 267,
     NUM = 268,
     ENUM = 269,
     RTRID = 270,
     IPA = 271,
     SYM = 272,
     TEXT = 273,
     PREFIX_DUMMY = 274,
     DEFINE = 275,
     ON = 276,
     OFF = 277,
     YES = 278,
     NO = 279,
     LOG = 280,
     SYSLOG = 281,
     ALL = 282,
     DEBUG = 283,
     TRACE = 284,
     INFO = 285,
     REMOTE = 286,
     WARNING = 287,
     ERROR = 288,
     AUTH = 289,
     FATAL = 290,
     BUG = 291,
     STDERR = 292,
     SOFT = 293,
     CONFIGURE = 294,
     DOWN = 295,
     KERNEL = 296,
     PERSIST = 297,
     SCAN = 298,
     TIME = 299,
     LEARN = 300,
     DEVICE = 301,
     ASYNC = 302,
     TABLE = 303,
     ROUTER = 304,
     ID = 305,
     PROTOCOL = 306,
     PREFERENCE = 307,
     DISABLED = 308,
     DIRECT = 309,
     INTERFACE = 310,
     IMPORT = 311,
     EXPORT = 312,
     FILTER = 313,
     NONE = 314,
     STATES = 315,
     ROUTES = 316,
     FILTERS = 317,
     PASSWORD = 318,
     FROM = 319,
     PASSIVE = 320,
     TO = 321,
     EVENTS = 322,
     PACKETS = 323,
     PROTOCOLS = 324,
     INTERFACES = 325,
     PRIMARY = 326,
     STATS = 327,
     COUNT = 328,
     FOR = 329,
     COMMANDS = 330,
     PREEXPORT = 331,
     GENERATE = 332,
     LISTEN = 333,
     BGP = 334,
     V6ONLY = 335,
     ADDRESS = 336,
     PORT = 337,
     PASSWORDS = 338,
     DESCRIPTION = 339,
     RELOAD = 340,
     IN = 341,
     OUT = 342,
     MRTDUMP = 343,
     MESSAGES = 344,
     SHOW = 345,
     STATUS = 346,
     SUMMARY = 347,
     ROUTE = 348,
     SYMBOLS = 349,
     DUMP = 350,
     RESOURCES = 351,
     SOCKETS = 352,
     NEIGHBORS = 353,
     ATTRIBUTES = 354,
     ECHO = 355,
     DISABLE = 356,
     ENABLE = 357,
     RESTART = 358,
     FUNCTION = 359,
     PRINT = 360,
     PRINTN = 361,
     UNSET = 362,
     RETURN = 363,
     ACCEPT = 364,
     REJECT = 365,
     QUITBIRD = 366,
     INT = 367,
     BOOL = 368,
     IP = 369,
     PREFIX = 370,
     PAIR = 371,
     SET = 372,
     STRING = 373,
     BGPMASK = 374,
     BGPPATH = 375,
     CLIST = 376,
     IF = 377,
     THEN = 378,
     ELSE = 379,
     CASE = 380,
     TRUE = 381,
     FALSE = 382,
     GW = 383,
     NET = 384,
     MASK = 385,
     PROTO = 386,
     SOURCE = 387,
     SCOPE = 388,
     CAST = 389,
     DEST = 390,
     LEN = 391,
     DEFINED = 392,
     ADD = 393,
     DELETE = 394,
     CONTAINS = 395,
     RESET = 396,
     PREPEND = 397,
     FIRST = 398,
     LAST = 399,
     MATCH = 400,
     EMPTY = 401,
     WHERE = 402,
     EVAL = 403,
     LOCAL = 404,
     NEIGHBOR = 405,
     AS = 406,
     HOLD = 407,
     CONNECT = 408,
     RETRY = 409,
     KEEPALIVE = 410,
     MULTIHOP = 411,
     STARTUP = 412,
     VIA = 413,
     NEXT = 414,
     HOP = 415,
     SELF = 416,
     DEFAULT = 417,
     PATH = 418,
     METRIC = 419,
     START = 420,
     DELAY = 421,
     FORGET = 422,
     WAIT = 423,
     AFTER = 424,
     BGP_PATH = 425,
     BGP_LOCAL_PREF = 426,
     BGP_MED = 427,
     BGP_ORIGIN = 428,
     BGP_NEXT_HOP = 429,
     BGP_ATOMIC_AGGR = 430,
     BGP_AGGREGATOR = 431,
     BGP_COMMUNITY = 432,
     RR = 433,
     RS = 434,
     CLIENT = 435,
     CLUSTER = 436,
     AS4 = 437,
     ADVERTISE = 438,
     IPV4 = 439,
     CAPABILITIES = 440,
     LIMIT = 441,
     PREFER = 442,
     OLDER = 443,
     MISSING = 444,
     LLADDR = 445,
     DROP = 446,
     IGNORE = 447,
     REFRESH = 448,
     OSPF = 449,
     AREA = 450,
     OSPF_METRIC1 = 451,
     OSPF_METRIC2 = 452,
     OSPF_TAG = 453,
     BROADCAST = 454,
     RFC1583COMPAT = 455,
     STUB = 456,
     TICK = 457,
     COST = 458,
     RETRANSMIT = 459,
     HELLO = 460,
     TRANSMIT = 461,
     PRIORITY = 462,
     DEAD = 463,
     NONBROADCAST = 464,
     POINTOPOINT = 465,
     TYPE = 466,
     SIMPLE = 467,
     AUTHENTICATION = 468,
     STRICT = 469,
     CRYPTOGRAPHIC = 470,
     ELIGIBLE = 471,
     POLL = 472,
     NETWORKS = 473,
     HIDDEN = 474,
     VIRTUAL = 475,
     LINK = 476,
     RX = 477,
     BUFFER = 478,
     LARGE = 479,
     NORMAL = 480,
     STUBNET = 481,
     LSADB = 482,
     TOPOLOGY = 483,
     STATE = 484,
     PIPE = 485,
     PEER = 486,
     MODE = 487,
     OPAQUE = 488,
     TRANSPARENT = 489,
     RIP = 490,
     INFINITY = 491,
     PERIOD = 492,
     GARBAGE = 493,
     TIMEOUT = 494,
     MULTICAST = 495,
     QUIET = 496,
     NOLISTEN = 497,
     VERSION1 = 498,
     PLAINTEXT = 499,
     MD5 = 500,
     HONOR = 501,
     NEVER = 502,
     ALWAYS = 503,
     RIP_METRIC = 504,
     RIP_TAG = 505,
     STATIC = 506,
     PROHIBIT = 507
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 157 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;



/* Line 214 of yacc.c  */
#line 546 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 558 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  49
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1566

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  274
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  189
/* YYNRULES -- Number of rules.  */
#define YYNRULES  573
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1076

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   507

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     264,   265,    27,    25,   270,    26,    24,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   267,   266,
      21,    20,    22,   271,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   272,     2,   273,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   268,     2,   269,    23,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    73,
      75,    77,    79,    83,    85,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   112,   116,   120,   125,   128,
     129,   131,   134,   137,   141,   144,   147,   151,   155,   159,
     164,   166,   168,   170,   175,   176,   179,   182,   185,   187,
     190,   192,   193,   195,   196,   199,   202,   205,   208,   211,
     214,   217,   221,   224,   227,   229,   231,   233,   235,   239,
     243,   244,   246,   248,   251,   252,   254,   258,   260,   264,
     267,   271,   275,   279,   280,   284,   286,   288,   292,   294,
     298,   300,   302,   304,   306,   308,   310,   312,   314,   318,
     320,   324,   326,   328,   333,   335,   336,   340,   345,   347,
     350,   351,   357,   363,   369,   375,   380,   384,   389,   395,
     397,   398,   402,   407,   412,   413,   416,   420,   424,   428,
     431,   434,   437,   441,   445,   448,   451,   453,   455,   460,
     464,   468,   472,   476,   480,   484,   488,   493,   495,   497,
     499,   500,   502,   506,   510,   514,   518,   523,   528,   533,
     538,   540,   542,   544,   545,   550,   553,   555,   557,   559,
     561,   563,   565,   567,   569,   571,   574,   577,   578,   582,
     584,   588,   590,   592,   594,   597,   601,   604,   609,   610,
     616,   617,   620,   622,   626,   632,   634,   636,   638,   640,
     642,   644,   649,   651,   655,   659,   661,   664,   667,   674,
     676,   680,   681,   686,   690,   692,   696,   700,   704,   707,
     710,   713,   716,   717,   720,   723,   724,   730,   732,   734,
     736,   738,   740,   742,   746,   750,   752,   754,   755,   760,
     762,   764,   766,   768,   770,   772,   774,   776,   778,   782,
     786,   790,   794,   798,   802,   806,   810,   814,   818,   822,
     826,   830,   834,   837,   842,   844,   846,   848,   850,   853,
     856,   860,   864,   871,   875,   879,   883,   887,   894,   901,
     908,   913,   915,   917,   919,   921,   923,   925,   927,   928,
     930,   934,   936,   940,   941,   943,   948,   955,   960,   964,
     970,   976,   981,   988,   992,   995,  1001,  1007,  1016,  1025,
    1034,  1037,  1041,  1045,  1051,  1058,  1065,  1070,  1075,  1081,
    1088,  1095,  1101,  1108,  1114,  1120,  1126,  1132,  1138,  1144,
    1150,  1156,  1162,  1169,  1176,  1185,  1192,  1199,  1205,  1210,
    1216,  1221,  1227,  1232,  1235,  1239,  1243,  1245,  1248,  1251,
    1254,  1258,  1261,  1262,  1266,  1270,  1273,  1278,  1281,  1284,
    1286,  1291,  1293,  1295,  1296,  1300,  1303,  1306,  1309,  1314,
    1316,  1317,  1321,  1322,  1325,  1328,  1332,  1335,  1338,  1342,
    1345,  1348,  1351,  1353,  1357,  1360,  1363,  1366,  1369,  1373,
    1376,  1379,  1382,  1386,  1389,  1392,  1395,  1399,  1402,  1407,
    1410,  1413,  1416,  1420,  1424,  1428,  1430,  1431,  1434,  1436,
    1438,  1441,  1445,  1446,  1449,  1451,  1453,  1456,  1460,  1461,
    1462,  1466,  1467,  1471,  1475,  1477,  1478,  1483,  1490,  1497,
    1504,  1511,  1518,  1521,  1525,  1529,  1535,  1540,  1545,  1548,
    1552,  1556,  1561,  1566,  1571,  1577,  1583,  1588,  1592,  1597,
    1602,  1607,  1612,  1614,  1616,  1618,  1620,  1622,  1624,  1626,
    1628,  1629,  1632,  1635,  1636,  1640,  1641,  1645,  1646,  1650,
    1653,  1657,  1661,  1665,  1668,  1672,  1676,  1679,  1682,  1685,
    1690,  1692,  1694,  1696,  1698,  1700,  1702,  1704,  1706,  1708,
    1710,  1712,  1714,  1716,  1718,  1720,  1722,  1724,  1726,  1728,
    1730,  1732,  1734,  1736,  1738,  1740,  1742,  1744,  1746,  1748,
    1750,  1752,  1754,  1756,  1758,  1760,  1762,  1764,  1766,  1768,
    1770,  1772,  1774,  1776,  1778,  1780,  1783,  1786,  1789,  1792,
    1795,  1798,  1801,  1804,  1808,  1812,  1816,  1820,  1824,  1828,
    1832,  1834,  1836,  1838,  1840,  1842,  1844,  1846,  1848,  1850,
    1852,  1854,  1856,  1858
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     275,     0,    -1,   276,     3,    -1,     4,   458,    -1,    -1,
     276,   457,    -1,    13,    -1,   264,   397,   265,    -1,    17,
      -1,    31,    17,    20,   277,   266,    -1,    31,    17,    20,
      16,   266,    -1,   277,    -1,    32,    -1,    34,    -1,    33,
      -1,    35,    -1,    -1,    16,    -1,    17,    -1,   280,   283,
      -1,   281,    -1,   280,    -1,    28,   277,    -1,   267,   280,
      -1,    18,    -1,    18,    -1,    -1,    36,   287,   288,   266,
      -1,    18,    -1,    37,    -1,    48,    -1,    38,    -1,   268,
     289,   269,    -1,   290,    -1,   289,   270,   290,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,    46,    -1,    47,    -1,    99,    80,   325,
     266,    -1,    99,    18,   266,    -1,    50,   295,     3,    -1,
      50,    49,   295,     3,    -1,    51,     3,    -1,    -1,    18,
      -1,   307,    52,    -1,    53,   279,    -1,    54,    55,   277,
      -1,    56,   279,    -1,   307,    57,    -1,    54,    55,   277,
      -1,    82,   285,   282,    -1,    52,    59,   277,    -1,    60,
      61,   302,   266,    -1,    13,    -1,    15,    -1,    16,    -1,
      89,    90,   304,   266,    -1,    -1,   304,   305,    -1,    92,
     280,    -1,    93,   277,    -1,    91,    -1,    59,    17,    -1,
      62,    -1,    -1,    17,    -1,    -1,    63,   277,    -1,    64,
     279,    -1,    39,   322,    -1,    99,   325,    -1,    67,   310,
      -1,    68,   310,    -1,    59,   311,    -1,    60,    61,   302,
      -1,    95,    18,    -1,    69,   370,    -1,   371,    -1,    38,
      -1,    70,    -1,    17,    -1,    39,    80,   322,    -1,    39,
      86,   277,    -1,    -1,    18,    -1,   281,    -1,    18,   281,
      -1,    -1,    26,    -1,   313,   315,   314,    -1,   316,    -1,
     317,   270,   316,    -1,   307,    65,    -1,   318,   308,   268,
      -1,   319,   309,   266,    -1,   319,   321,   266,    -1,    -1,
      66,   320,   317,    -1,    38,    -1,    33,    -1,   268,   323,
     269,    -1,   324,    -1,   323,   270,   324,    -1,    71,    -1,
      72,    -1,    73,    -1,    81,    -1,    78,    -1,    79,    -1,
      38,    -1,    33,    -1,   268,   326,   269,    -1,   327,    -1,
     326,   270,   327,    -1,    71,    -1,   100,    -1,    94,   268,
     329,   269,    -1,   330,    -1,    -1,   330,   266,   329,    -1,
     331,   268,   332,   269,    -1,   331,    -1,    74,    18,    -1,
      -1,    88,    75,   284,   266,   332,    -1,    88,    77,   284,
     266,   332,    -1,   120,    75,   284,   266,   332,    -1,   120,
      77,   284,   266,   332,    -1,    61,   277,   266,   332,    -1,
     101,   102,     3,    -1,   101,    80,   336,     3,    -1,   101,
      80,    38,   336,     3,    -1,    17,    -1,    -1,   101,    81,
       3,    -1,   101,    81,   103,     3,    -1,   101,   104,   340,
       3,    -1,    -1,   340,   281,    -1,   340,    85,   282,    -1,
     340,    59,    17,    -1,   340,    69,   370,    -1,   340,   371,
      -1,   340,    38,    -1,   340,    82,    -1,   340,   341,    17,
      -1,   340,    62,    17,    -1,   340,    83,    -1,   340,    84,
      -1,    87,    -1,    68,    -1,   101,   105,   336,     3,    -1,
     106,   107,     3,    -1,   106,   108,     3,    -1,   106,    81,
       3,    -1,   106,   109,     3,    -1,   106,   110,     3,    -1,
     106,    72,     3,    -1,   106,    80,     3,    -1,   111,   351,
     352,     3,    -1,    38,    -1,    33,    -1,    13,    -1,    -1,
      13,    -1,   112,   361,     3,    -1,   113,   361,     3,    -1,
     114,   361,     3,    -1,    96,   361,     3,    -1,    96,    97,
     361,     3,    -1,    96,    98,   361,     3,    -1,    39,   361,
     322,     3,    -1,    99,   361,   325,     3,    -1,    17,    -1,
      38,    -1,    18,    -1,    -1,    69,    17,   363,   369,    -1,
     159,   397,    -1,   123,    -1,   124,    -1,   125,    -1,   126,
      -1,   127,    -1,   129,    -1,   130,    -1,   131,    -1,   132,
      -1,   365,   128,    -1,   365,    17,    -1,    -1,   366,   266,
     367,    -1,   366,    -1,   368,   266,   366,    -1,   373,    -1,
      17,    -1,   369,    -1,   158,   397,    -1,   264,   368,   265,
      -1,   264,   265,    -1,   367,   268,   376,   269,    -1,    -1,
     115,    17,   375,   372,   373,    -1,    -1,   403,   376,    -1,
     403,    -1,   268,   376,   269,    -1,   264,    13,   270,    13,
     265,    -1,    16,    -1,    13,    -1,   378,    -1,   379,    -1,
      14,    -1,   380,    -1,   380,    24,    24,   380,    -1,   381,
      -1,   382,   270,   381,    -1,    16,    28,    13,    -1,   383,
      -1,   383,    25,    -1,   383,    26,    -1,   383,   268,    13,
     270,    13,   269,    -1,   384,    -1,   385,   270,   384,    -1,
      -1,   381,   267,   376,   386,    -1,   135,   267,   376,    -1,
     395,    -1,   264,   397,   265,    -1,    11,   389,    12,    -1,
      28,   390,    28,    -1,    13,   389,    -1,    27,   389,    -1,
     271,   389,    -1,   387,   389,    -1,    -1,    13,   390,    -1,
     271,   390,    -1,    -1,   264,   397,   270,   397,   265,    -1,
      13,    -1,   137,    -1,   138,    -1,    18,    -1,   379,    -1,
     383,    -1,   272,   382,   273,    -1,   272,   385,   273,    -1,
      14,    -1,   388,    -1,    -1,    17,   264,   402,   265,    -1,
      17,    -1,    75,    -1,   139,    -1,   140,    -1,   142,    -1,
     143,    -1,   144,    -1,   145,    -1,   146,    -1,   264,   397,
     265,    -1,   397,    25,   397,    -1,   397,    26,   397,    -1,
     397,    27,   397,    -1,   397,    28,   397,    -1,   397,     9,
     397,    -1,   397,    10,   397,    -1,   397,    20,   397,    -1,
     397,     8,   397,    -1,   397,    21,   397,    -1,   397,     7,
     397,    -1,   397,    22,   397,    -1,   397,     6,   397,    -1,
     397,    23,   397,    -1,    30,   397,    -1,   148,   264,   397,
     265,    -1,   395,    -1,   392,    -1,   391,    -1,    63,    -1,
     393,   396,    -1,   393,   462,    -1,   397,    24,   125,    -1,
     397,    24,   147,    -1,   397,    24,   141,   264,   397,   265,
      -1,   397,    24,   154,    -1,   397,    24,   155,    -1,    25,
     157,    25,    -1,    26,   157,    26,    -1,   153,   264,   397,
     270,   397,   265,    -1,   149,   264,   397,   270,   397,   265,
      -1,   150,   264,   397,   270,   397,   265,    -1,    17,   264,
     402,   265,    -1,   122,    -1,   120,    -1,   121,    -1,    44,
      -1,   116,    -1,   117,    -1,   397,    -1,    -1,   399,    -1,
     399,   270,   400,    -1,   397,    -1,   397,   270,   401,    -1,
      -1,   401,    -1,   133,   397,   134,   377,    -1,   133,   397,
     134,   377,   135,   377,    -1,    17,    20,   397,   266,    -1,
     119,   397,   266,    -1,   393,   462,    20,   397,   266,    -1,
     393,   396,    20,   397,   266,    -1,    63,    20,   397,   266,
      -1,   118,   264,   393,   462,   265,   266,    -1,   398,   400,
     266,    -1,   394,   266,    -1,   136,   397,   268,   386,   269,
      -1,   393,   462,    24,   157,   266,    -1,   393,   462,    24,
     153,   264,   397,   265,   266,    -1,   393,   462,    24,   149,
     264,   397,   265,   266,    -1,   393,   462,    24,   150,   264,
     397,   265,   266,    -1,   307,    90,    -1,   404,   308,   268,
      -1,   405,   309,   266,    -1,   405,   160,   162,   277,   266,
      -1,   405,   161,   280,   162,   277,   266,    -1,   405,   189,
     192,    61,   277,   266,    -1,   405,   189,   191,   266,    -1,
     405,   190,   191,   266,    -1,   405,   163,    55,   277,   266,
      -1,   405,   168,   163,    55,   277,   266,    -1,   405,   164,
     165,    55,   277,   266,    -1,   405,   166,    55,   277,   266,
      -1,   405,   167,   277,   169,   280,   266,    -1,   405,   170,
     171,   172,   266,    -1,   405,   200,   201,   172,   266,    -1,
     405,   200,   201,   202,   266,    -1,   405,   200,   201,   203,
     266,    -1,   405,   174,   175,   279,   266,    -1,   405,   198,
     199,   279,   266,    -1,   405,   173,   183,   277,   266,    -1,
     405,   173,   182,   277,   266,    -1,   405,   143,    92,   280,
     266,    -1,   405,   176,   177,    55,   277,   266,    -1,   405,
      44,   178,    55,   277,   266,    -1,   405,    44,   179,    55,
     277,   270,   277,   266,    -1,   405,   112,   180,    44,   279,
     266,    -1,   405,   113,   104,   204,   279,   266,    -1,   405,
     113,   193,   279,   266,    -1,   405,   196,   279,   266,    -1,
     405,   194,   195,   279,   266,    -1,   405,    74,    18,   266,
      -1,   405,   104,   197,   277,   266,    -1,   405,    76,   279,
     266,    -1,   307,   205,    -1,   406,   308,   268,    -1,   407,
     408,   266,    -1,   309,    -1,   211,   279,    -1,   213,   277,
      -1,   410,   269,    -1,   206,   302,   268,    -1,   409,   411,
      -1,    -1,   411,   412,   266,    -1,   212,   214,   277,    -1,
     212,   279,    -1,   229,   268,   422,   269,    -1,   237,   413,
      -1,    66,   433,    -1,   417,    -1,   414,   268,   415,   269,
      -1,   414,    -1,   281,    -1,    -1,   415,   416,   266,    -1,
     230,   279,    -1,   103,   279,    -1,   214,   277,    -1,   420,
     268,   418,   269,    -1,   420,    -1,    -1,   418,   419,   266,
      -1,    -1,   216,   277,    -1,   215,   277,    -1,   217,   177,
     277,    -1,   179,   277,    -1,   219,   277,    -1,   219,    84,
     277,    -1,   224,    70,    -1,   224,   223,    -1,   224,   226,
      -1,   328,    -1,   231,   232,   302,    -1,   214,   277,    -1,
     216,   277,    -1,   228,   277,    -1,   215,   277,    -1,   217,
     177,   277,    -1,   218,   277,    -1,   179,   277,    -1,   219,
     277,    -1,   219,    84,   277,    -1,   222,   210,    -1,   222,
     220,    -1,   222,   221,    -1,   225,   220,   279,    -1,   212,
     279,    -1,   109,   268,   426,   269,    -1,   224,    70,    -1,
     224,   223,    -1,   224,   226,    -1,   233,   234,   235,    -1,
     233,   234,   236,    -1,   233,   234,   277,    -1,   328,    -1,
      -1,   422,   423,    -1,   424,    -1,   425,    -1,   281,   266,
      -1,   281,   230,   266,    -1,    -1,   426,   427,    -1,   428,
      -1,   429,    -1,    16,   266,    -1,    16,   227,   266,    -1,
      -1,    -1,   431,   421,   266,    -1,    -1,   268,   431,   269,
      -1,   430,   317,   432,    -1,    18,    -1,    -1,   101,   205,
     336,     3,    -1,   101,   205,   109,   336,   434,     3,    -1,
     101,   205,    66,   336,   434,     3,    -1,   101,   205,   239,
     336,   434,     3,    -1,   101,   205,   240,   336,   434,     3,
      -1,   101,   205,   238,   336,   434,     3,    -1,   307,   241,
      -1,   441,   308,   268,    -1,   442,   309,   266,    -1,   442,
     242,    59,    17,   266,    -1,   442,   243,   244,   266,    -1,
     442,   243,   245,   266,    -1,   307,   246,    -1,   443,   308,
     268,    -1,   444,   309,   266,    -1,   444,   247,   277,   266,
      -1,   444,    93,   277,   266,    -1,   444,   248,   277,   266,
      -1,   444,   249,    55,   277,   266,    -1,   444,   250,    55,
     277,   266,    -1,   444,   224,   445,   266,    -1,   444,   328,
     266,    -1,   444,   257,   259,   266,    -1,   444,   257,   161,
     266,    -1,   444,   257,   258,   266,    -1,   444,    66,   451,
     266,    -1,   255,    -1,   256,    -1,    70,    -1,   210,    -1,
     251,    -1,   252,    -1,   253,    -1,   254,    -1,    -1,   175,
     277,    -1,   243,   446,    -1,    -1,   448,   447,   266,    -1,
      -1,   268,   448,   269,    -1,    -1,   450,   317,   449,    -1,
     307,   262,    -1,   452,   308,   268,    -1,   453,   309,   266,
      -1,   453,   455,   266,    -1,   104,   281,    -1,   454,   169,
     280,    -1,   454,   169,    18,    -1,   454,   202,    -1,   454,
     121,    -1,   454,   263,    -1,   101,   262,   336,     3,    -1,
     266,    -1,   278,    -1,   286,    -1,   291,    -1,   301,    -1,
     303,    -1,   306,    -1,   459,    -1,   312,    -1,   362,    -1,
     364,    -1,   374,    -1,   292,    -1,   293,    -1,   294,    -1,
     333,    -1,   334,    -1,   335,    -1,   337,    -1,   338,    -1,
     339,    -1,   342,    -1,   343,    -1,   344,    -1,   345,    -1,
     346,    -1,   347,    -1,   348,    -1,   349,    -1,   350,    -1,
     353,    -1,   354,    -1,   355,    -1,   356,    -1,   357,    -1,
     358,    -1,   359,    -1,   360,    -1,   435,    -1,   436,    -1,
     437,    -1,   438,    -1,   439,    -1,   440,    -1,   456,    -1,
     460,   269,    -1,   461,   269,    -1,   319,   269,    -1,   405,
     269,    -1,   407,   269,    -1,   442,   269,    -1,   444,   269,
      -1,   453,   269,    -1,   296,   308,   268,    -1,   460,   309,
     266,    -1,   460,   297,   266,    -1,   460,   300,   266,    -1,
     298,   308,   268,    -1,   461,   309,   266,    -1,   461,   299,
     266,    -1,     5,    -1,   181,    -1,   182,    -1,   183,    -1,
     184,    -1,   185,    -1,   186,    -1,   187,    -1,   188,    -1,
     207,    -1,   208,    -1,   209,    -1,   260,    -1,   261,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   306,   306,   307,   310,   312,   319,   320,   321,   325,
     329,   338,   339,   340,   341,   342,   343,   349,   350,   357,
     364,   365,   369,   373,   380,   388,   389,   395,   404,   409,
     410,   414,   415,   419,   420,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   438,   439,   452,   455,   458,   462,
     463,   471,   487,   488,   492,   504,   517,   521,   534,   546,
     552,   553,   554,   565,   567,   569,   573,   574,   575,   582,
     590,   594,   600,   606,   608,   612,   613,   614,   615,   616,
     617,   618,   619,   623,   624,   625,   626,   630,   638,   639,
     647,   655,   656,   657,   661,   662,   666,   671,   672,   679,
     688,   689,   690,   694,   703,   709,   710,   711,   715,   716,
     720,   721,   722,   723,   724,   725,   731,   732,   733,   737,
     738,   742,   743,   749,   750,   753,   755,   759,   760,   764,
     782,   783,   784,   785,   786,   787,   795,   798,   801,   805,
     806,   809,   812,   815,   819,   825,   831,   838,   843,   848,
     853,   857,   861,   871,   879,   883,   890,   891,   894,   898,
     900,   902,   904,   906,   908,   910,   913,   919,   920,   921,
     925,   926,   932,   934,   936,   938,   940,   942,   946,   951,
     956,   957,   958,   964,   964,   973,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,  1005,  1016,  1017,  1024,
    1025,  1032,  1041,  1045,  1049,  1073,  1074,  1078,  1084,  1084,
    1097,  1098,  1109,  1112,  1121,  1128,  1132,  1133,  1134,  1135,
    1139,  1144,  1152,  1153,  1157,  1164,  1165,  1166,  1167,  1174,
    1175,  1178,  1179,  1184,  1195,  1196,  1200,  1201,  1205,  1206,
    1207,  1208,  1209,  1213,  1214,  1215,  1219,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1251,  1255,  1278,
    1311,  1313,  1314,  1315,  1316,  1317,  1318,  1319,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1340,  1341,  1342,  1344,  1346,  1348,
    1350,  1351,  1352,  1353,  1354,  1364,  1365,  1366,  1367,  1368,
    1373,  1396,  1397,  1398,  1399,  1400,  1401,  1405,  1408,  1409,
    1410,  1419,  1426,  1435,  1436,  1440,  1446,  1456,  1465,  1471,
    1476,  1483,  1488,  1494,  1495,  1496,  1504,  1506,  1507,  1508,
    1514,  1534,  1535,  1536,  1537,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,
    1558,  1559,  1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,
    1568,  1569,  1570,  1579,  1589,  1590,  1594,  1595,  1596,  1597,
    1600,  1612,  1615,  1617,  1621,  1622,  1623,  1624,  1625,  1626,
    1630,  1631,  1635,  1643,  1645,  1649,  1650,  1651,  1655,  1656,
    1659,  1661,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1677,  1699,  1700,  1701,  1702,  1703,  1704,
    1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,
    1715,  1716,  1717,  1718,  1719,  1720,  1723,  1725,  1729,  1730,
    1732,  1741,  1751,  1753,  1757,  1758,  1760,  1769,  1780,  1802,
    1804,  1807,  1809,  1813,  1817,  1818,  1822,  1825,  1828,  1831,
    1834,  1837,  1843,  1851,  1852,  1853,  1858,  1859,  1865,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,
    1883,  1884,  1888,  1889,  1890,  1895,  1896,  1897,  1898,  1899,
    1902,  1903,  1904,  1907,  1909,  1912,  1914,  1918,  1927,  1934,
    1941,  1942,  1943,  1946,  1955,  1959,  1965,  1966,  1967,  1970,
    1977,  1977,  1977,  1977,  1977,  1977,  1977,  1977,  1977,  1977,
    1977,  1977,  1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,
    1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,
    1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,  1978,
    1978,  1978,  1978,  1978,  1978,  1979,  1979,  1979,  1979,  1979,
    1979,  1979,  1979,  1980,  1980,  1980,  1980,  1981,  1981,  1981,
    1982,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,
    1990,  1990,  1990,  1990
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "RTRID",
  "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'", "'~'", "'.'",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "DEFINE", "ON", "OFF", "YES",
  "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE",
  "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ASYNC", "TABLE", "ROUTER", "ID", "PROTOCOL", "PREFERENCE",
  "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE",
  "STATES", "ROUTES", "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO",
  "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP",
  "V6ONLY", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "SHOW", "STATUS", "SUMMARY", "ROUTE",
  "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES",
  "ECHO", "DISABLE", "ENABLE", "RESTART", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "GW", "NET", "MASK", "PROTO",
  "SOURCE", "SCOPE", "CAST", "DEST", "LEN", "DEFINED", "ADD", "DELETE",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "EMPTY",
  "WHERE", "EVAL", "LOCAL", "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY",
  "KEEPALIVE", "MULTIHOP", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "WAIT", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES", "LIMIT",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "BROADCAST",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "NONBROADCAST", "POINTOPOINT", "TYPE",
  "SIMPLE", "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "LSADB", "TOPOLOGY", "STATE", "PIPE", "PEER",
  "MODE", "OPAQUE", "TRANSPARENT", "RIP", "INFINITY", "PERIOD", "GARBAGE",
  "TIMEOUT", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1", "PLAINTEXT",
  "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG", "STATIC",
  "PROHIBIT", "'('", "')'", "';'", "':'", "'{'", "'}'", "','", "'?'",
  "'['", "']'", "$accept", "config", "conf_entries", "expr", "definition",
  "bool", "ipa", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "log_file", "log_mask", "log_mask_list",
  "log_cat", "mrtdump_base", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_DOWN", "cfg_name", "kern_proto_start", "kern_item",
  "kif_proto_start", "kif_item", "nl_item", "rtrid", "idval", "listen",
  "listen_opts", "listen_opt", "newtab", "proto_start", "proto_name",
  "proto_item", "imexport", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "proto_patt", "filter_def", "$@1", "filter_eval", "type", "one_decl",
  "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "block", "cpair", "fipa", "set_atom", "set_item", "set_items",
  "fprefix_s", "fprefix", "fprefix_set", "switch_body", "bgp_path_expr",
  "bgp_path", "bgp_path_tail1", "bgp_path_tail2", "dpair", "constant",
  "rtadot", "function_call", "symbol", "static_attr", "term",
  "break_command", "print_one", "print_list", "var_listn", "var_list",
  "cmd", "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_el", "pref_hid",
  "ipa_list", "ipa_item", "ipa_el", "ipa_ne", "ospf_iface_start",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_LSADB",
  "pipe_proto_start", "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth",
  "rip_mode", "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      61,    60,    62,   126,    46,    43,    45,    42,    47,    37,
      33,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    40,    41,    59,    58,   123,   125,
      44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   274,   275,   275,   276,   276,   277,   277,   277,   278,
     278,   279,   279,   279,   279,   279,   279,   280,   280,   281,
     282,   282,   283,   283,   284,   285,   285,   286,   287,   287,
     287,   288,   288,   289,   289,   290,   290,   290,   290,   290,
     290,   290,   290,   290,   291,   291,   292,   293,   294,   295,
     295,   296,   297,   297,   297,   298,   299,   299,   300,   301,
     302,   302,   302,   303,   304,   304,   305,   305,   305,   306,
     307,   308,   308,   309,   309,   309,   309,   309,   309,   309,
     309,   309,   309,   310,   310,   310,   310,   311,   312,   312,
     313,   314,   314,   314,   315,   315,   316,   317,   317,   318,
     319,   319,   319,   320,   321,   322,   322,   322,   323,   323,
     324,   324,   324,   324,   324,   324,   325,   325,   325,   326,
     326,   327,   327,   328,   328,   329,   329,   330,   330,   331,
     332,   332,   332,   332,   332,   332,   333,   334,   335,   336,
     336,   337,   338,   339,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   341,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   351,   351,
     352,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   361,   361,   363,   362,   364,   365,   365,   365,   365,
     365,   365,   365,   365,   365,   365,   366,   367,   367,   368,
     368,   369,   370,   370,   371,   372,   372,   373,   375,   374,
     376,   376,   377,   377,   378,   379,   380,   380,   380,   380,
     381,   381,   382,   382,   383,   384,   384,   384,   384,   385,
     385,   386,   386,   386,   387,   387,   388,   388,   389,   389,
     389,   389,   389,   390,   390,   390,   391,   392,   392,   392,
     392,   392,   392,   392,   392,   392,   392,   393,   394,   395,
     396,   396,   396,   396,   396,   396,   396,   396,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   398,   398,   398,   398,   398,   398,   399,   400,   400,
     400,   401,   401,   402,   402,   403,   403,   403,   403,   403,
     403,   403,   403,   403,   403,   403,   403,   403,   403,   403,
     404,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   406,   407,   407,   408,   408,   408,   408,
     409,   410,   411,   411,   412,   412,   412,   412,   412,   412,
     413,   413,   414,   415,   415,   416,   416,   416,   417,   417,
     418,   418,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   420,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   422,   422,   423,   423,
     424,   425,   426,   426,   427,   427,   428,   429,   430,   431,
     431,   432,   432,   433,   434,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   442,   442,   442,   442,   443,   444,
     444,   444,   444,   444,   444,   444,   444,   444,   444,   444,
     444,   444,   445,   445,   445,   446,   446,   446,   446,   446,
     447,   447,   447,   448,   448,   449,   449,   450,   451,   452,
     453,   453,   453,   454,   455,   455,   455,   455,   455,   456,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   458,   458,   458,   458,   458,   458,   458,   458,
     458,   458,   458,   458,   458,   458,   458,   458,   458,   458,
     458,   458,   458,   458,   458,   458,   458,   458,   458,   458,
     458,   458,   458,   458,   458,   459,   459,   459,   459,   459,
     459,   459,   459,   460,   460,   460,   460,   461,   461,   461,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   462,
     462,   462,   462,   462
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     3,     4,     2,     0,
       1,     2,     2,     3,     2,     2,     3,     3,     3,     4,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     2,
       1,     0,     1,     0,     2,     2,     2,     2,     2,     2,
       2,     3,     2,     2,     1,     1,     1,     1,     3,     3,
       0,     1,     1,     2,     0,     1,     3,     1,     3,     2,
       3,     3,     3,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     4,     5,     1,
       0,     3,     4,     4,     0,     2,     3,     3,     3,     2,
       2,     2,     3,     3,     2,     2,     1,     1,     4,     3,
       3,     3,     3,     3,     3,     3,     4,     1,     1,     1,
       0,     1,     3,     3,     3,     3,     4,     4,     4,     4,
       1,     1,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     0,     3,     1,
       3,     1,     1,     1,     2,     3,     2,     4,     0,     5,
       0,     2,     1,     3,     5,     1,     1,     1,     1,     1,
       1,     4,     1,     3,     3,     1,     2,     2,     6,     1,
       3,     0,     4,     3,     1,     3,     3,     3,     2,     2,
       2,     2,     0,     2,     2,     0,     5,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     4,     1,     1,     1,     1,     2,     2,
       3,     3,     6,     3,     3,     3,     3,     6,     6,     6,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       2,     3,     3,     5,     6,     6,     4,     4,     5,     6,
       6,     5,     6,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     8,     6,     6,     5,     4,     5,
       4,     5,     4,     2,     3,     3,     1,     2,     2,     2,
       3,     2,     0,     3,     3,     2,     4,     2,     2,     1,
       4,     1,     1,     0,     3,     2,     2,     2,     4,     1,
       0,     3,     0,     2,     2,     3,     2,     2,     3,     2,
       2,     2,     1,     3,     2,     2,     2,     2,     3,     2,
       2,     2,     3,     2,     2,     2,     3,     2,     4,     2,
       2,     2,     3,     3,     3,     1,     0,     2,     1,     1,
       2,     3,     0,     2,     1,     1,     2,     3,     0,     0,
       3,     0,     3,     3,     1,     0,     4,     6,     6,     6,
       6,     6,     2,     3,     3,     5,     4,     4,     2,     3,
       3,     4,     4,     4,     5,     5,     4,     3,     4,     4,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     2,     0,     3,     0,     3,     0,     3,     2,
       3,     3,     3,     2,     3,     3,     2,     2,     2,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    49,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,     3,     1,
       2,     0,     0,     0,     0,     0,    70,     0,     0,     0,
       0,   257,   500,   501,   502,   503,    71,    71,   504,   505,
     506,     0,   508,    71,    73,   509,   510,   511,    71,    73,
      71,    73,    71,    73,    71,    73,    71,    73,     5,   507,
      73,    73,   180,   182,   181,     0,    50,    49,     0,    48,
       0,     0,     0,     0,   140,     0,     0,   144,   140,   140,
     140,     0,     0,     0,     0,     0,     0,     0,   169,   168,
     167,   170,     0,     0,     0,     0,    28,    29,    30,     0,
       0,     0,    69,     0,   183,    64,     0,     0,   208,   242,
     247,   255,   215,   259,   250,     0,     0,   245,   257,   287,
     248,   249,     0,     0,     0,     0,   257,     0,   251,   252,
     256,   286,   285,     0,   284,   185,    72,     0,     0,    51,
      55,    99,   330,   363,   452,   458,   489,     0,     0,     0,
       0,     0,    16,   103,     0,     0,     0,     0,   547,     0,
       0,     0,     0,     0,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,   548,     0,     0,     0,
      16,     0,   549,   366,     0,   372,     0,     0,     0,     0,
     550,     0,     0,   487,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   551,     0,     0,   124,   128,     0,     0,
     552,     0,     0,     0,     0,    16,     0,    16,   545,     0,
       0,     0,     0,    26,   546,     0,     0,   106,   105,     0,
       0,     0,    46,     0,     0,   175,   117,   116,     0,     0,
     139,   140,     0,   141,     0,   136,     0,     0,   140,   140,
     140,   140,   140,     0,     0,   164,   165,   161,   159,   160,
     162,   163,   171,     0,   172,   173,   174,     0,    31,     0,
       0,    88,     6,     8,   257,    89,    60,    61,    62,     0,
     197,     0,    45,     0,     0,   242,   259,   242,   257,   242,
     242,     0,   234,     0,   257,     0,     0,   245,   245,     0,
     282,   257,   257,   257,   257,     0,   216,   219,     0,   217,
     218,   220,   222,     0,   225,   229,     0,   560,   260,   261,
     262,   263,   264,   265,   266,   267,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   288,
     289,   257,   257,   257,   257,   257,   257,   257,   257,   257,
       0,   257,   257,   257,   257,   553,   557,   100,    76,    87,
      80,     0,    74,    12,    14,    13,    15,    11,    75,    90,
      85,   197,    86,   257,    78,    84,    79,    82,    77,   101,
     102,   331,     0,     0,     0,     0,     0,     0,     0,    16,
       0,     0,    17,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,     0,     0,    16,     0,
      16,     0,   332,   364,     0,   367,   368,   365,   371,   369,
     453,     0,     0,     0,   454,   459,    90,     0,   129,     0,
     125,   474,   472,   473,     0,     0,     0,     0,     0,     0,
       0,     0,   460,   467,   130,   490,     0,   493,   491,   497,
       0,   496,   498,   492,     0,    52,     0,    54,   555,   556,
     554,     0,    25,     0,   559,   558,   110,   111,   112,   114,
     115,   113,     0,   108,   178,    47,   176,   177,   121,   122,
       0,   119,   179,     0,   137,   142,   143,   150,     0,     0,
     157,   197,   151,   154,   155,     0,   156,   145,     0,   149,
     158,   445,   445,   445,   445,   445,   446,   499,   166,     0,
       0,    35,    36,    37,    38,    39,    40,    41,    42,    43,
       0,    33,    27,     0,    59,   186,   187,   188,   189,   190,
     191,   192,   193,   194,     0,     0,     0,   184,   201,    68,
       0,     0,    63,    65,    44,     0,   197,   238,   239,     0,
     240,   241,   236,   224,   311,   314,     0,   295,   296,   243,
     244,   237,     0,     0,     0,     0,   268,   257,     0,     0,
       0,   253,   226,   227,     0,     0,   254,   280,   278,   276,
     273,   274,   275,   277,   279,   281,   290,     0,   291,   293,
     294,   269,   270,   271,   272,    81,    94,    97,   104,   202,
     203,    83,   204,     0,     0,   360,   362,     0,    16,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   336,     0,   337,     0,   358,     0,
       0,     0,     0,   370,   438,    16,     0,     0,     0,     0,
     379,   389,     0,   456,   457,   485,   471,   462,     0,     0,
     466,   461,   463,     0,     0,   469,   470,   468,     0,     0,
       0,     0,     0,     0,    19,   495,   494,    58,    53,    56,
      21,    20,    57,   107,     0,   118,     0,   138,   147,   153,
     148,   146,   152,   444,     0,     0,     0,     0,     0,    10,
       9,    32,     0,     7,   196,   195,   197,   257,    66,    67,
     206,   199,     0,   209,   235,   257,   300,   283,   257,   257,
     257,     0,     0,     0,   215,   223,     0,     0,   230,   257,
      95,     0,    90,     0,     0,   361,     0,     0,   357,   351,
     333,     0,   338,     0,   341,     0,     0,   343,   350,   349,
     347,     0,     0,   359,   348,   344,   345,   346,    90,   378,
       0,   375,   426,     0,   382,   377,   381,   373,   390,   455,
     483,   488,   123,   125,   464,   465,     0,     0,     0,     0,
       0,   127,    22,    23,   109,   120,   448,   447,   451,   449,
     450,    34,   198,     0,   304,     0,   305,   306,     0,   257,
     302,   303,   301,   257,   257,     0,     0,     0,   257,   257,
     205,     0,   312,     0,     0,     0,   246,     0,   221,     0,
       0,    91,    92,    96,    98,   353,     0,   355,   356,   334,
     340,   342,   339,   352,   335,   441,   374,     0,   403,   383,
     392,   480,   126,   130,    24,     0,     0,     0,     0,   257,
     257,   257,   257,     0,     0,     0,   207,     0,     0,   324,
     307,   309,     0,   211,   200,   298,   299,   297,   214,     0,
     292,    93,     0,   439,   443,   376,     0,   427,   428,   429,
       0,     0,     0,     0,     0,     0,     0,   388,   402,     0,
       0,     0,   486,     0,   135,   130,   130,   130,   130,     0,
       0,     0,     0,   318,   257,   231,   257,   257,     0,   257,
     323,   228,   354,     0,     0,   430,    16,     0,    16,   380,
       0,   396,   394,   393,     0,     0,   397,   399,   400,   401,
     391,   481,   475,   476,   477,   478,   479,   482,   484,   131,
     132,   133,   134,   317,   258,   321,     0,   257,   315,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   310,
       0,     0,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   442,   425,     0,   431,   386,   387,
     385,   384,   395,   398,     0,     0,   257,   257,   257,   325,
     320,   319,   257,   257,   257,   326,   432,   410,   417,   404,
     407,   405,     0,   409,     0,   411,   413,   414,   415,   419,
     420,   421,    16,   406,     0,   440,   322,   213,   316,   233,
     231,     0,     0,     0,     0,   408,   412,   416,   422,   423,
     424,   232,     0,     0,     0,     0,   418,   433,   434,   435,
     328,   329,   327,     0,   436,   437
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   407,    63,   408,   486,   711,   712,   704,
     875,   503,    64,   129,   310,   560,   561,    65,    15,    16,
      17,    98,    66,   259,    67,   265,   260,    68,   319,    69,
     321,   583,    70,    71,   167,   189,   414,   400,    72,   636,
     853,   761,   637,   638,    73,    74,   409,   190,   270,   512,
     513,   279,   520,   521,   245,   688,   246,   247,   701,    18,
      19,    20,   282,    21,    22,    23,   286,   538,    24,    25,
      26,    27,    28,    29,    30,    31,    32,   121,   303,    33,
      34,    35,    36,    37,    38,    39,    40,    95,    75,   320,
      76,   574,   575,   576,   742,   640,   641,   415,   586,   578,
      77,   324,   835,   978,   349,   158,   351,   981,   353,   159,
     355,   356,   982,   330,   160,   331,   339,   161,   162,   163,
     837,   164,   379,   594,   838,   891,   892,   595,   596,   839,
      78,    79,    80,    81,   224,   225,   226,   458,   679,   795,
     796,   910,   950,   680,   870,   919,   681,  1006,   867,   907,
     908,   909,  1054,  1067,  1068,  1069,   788,   943,   904,   789,
     724,    41,    42,    43,    44,    45,    46,    82,    83,    84,
      85,   474,   967,   923,   871,   801,   466,   467,    86,    87,
     252,   253,    47,    88,    48,    89,    90,    91,   380
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -829
static const yytype_int16 yypact[] =
{
      71,  1393,    77,   204,   327,   216,   152,   513,   327,   233,
     365,   388,   327,   327,   327,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,    90,   196,   174,   157,   224,  -829,   241,   205,    39,
     283,   564,  -829,  -829,  -829,  -829,   300,   300,  -829,  -829,
    -829,   639,  -829,   300,  1279,  -829,  -829,  -829,   300,  1064,
     300,  1111,   300,   372,   300,  1209,   300,  1226,  -829,  -829,
    1066,  1228,  -829,  -829,  -829,    38,  -829,   331,   353,  -829,
     327,   327,   364,   118,   132,    70,   370,  -829,   367,   209,
     367,   385,   402,   411,   420,   431,   457,   460,  -829,  -829,
    -829,   389,   466,   474,   477,   463,  -829,  -829,  -829,   -12,
      38,    75,  -829,   338,  -829,  -829,   245,   118,  -829,    -2,
    -829,  -829,   487,   265,  -829,   377,   381,     0,   564,  -829,
    -829,  -829,   286,   303,   305,   312,   564,    65,  -829,  -829,
    -829,  -829,  -829,   885,  -829,  1506,  -829,   325,   329,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,   334,    38,   567,
     534,    75,    35,  -829,   217,   217,   595,   118,  -829,   355,
     390,   351,    53,   640,    35,   464,   484,   -41,   580,   520,
     230,   628,   519,   630,    75,   531,   524,   126,   522,   523,
     299,   508,   511,    35,   504,   507,  -829,   443,   442,   338,
      35,    75,  -829,  -829,   445,  -829,   446,   448,   664,   264,
    -829,   458,   459,  -829,   707,    75,   462,   -43,    75,    75,
     673,   676,   -68,  -829,   478,   483,  -829,   475,   482,   230,
    -829,   485,   181,   486,   694,    35,   699,    35,  -829,   490,
     499,   500,   714,   749,  -829,   505,   510,  -829,  -829,  1070,
     767,   771,  -829,   776,   781,  -829,  -829,  -829,    -6,   783,
    -829,   367,   784,  -829,   786,  -829,  1367,   793,   367,   367,
     367,   367,   367,   794,   795,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,   797,  -829,  -829,  -829,    30,  -829,  1519,
     536,  -829,  -829,  -829,   564,  -829,  -829,  -829,  -829,   537,
    1356,    93,  -829,   538,   550,    -2,  -829,    -2,   564,    -2,
      -2,   803,  -829,   775,   344,   791,   796,     0,     0,   799,
    -829,   564,   564,   564,   564,    76,  -829,  -829,   806,  -829,
    -829,   805,  -829,   130,    24,  -829,   136,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,   564,   564,   564,   564,   564,   564,   564,   564,   564,
     471,   564,   564,   564,   564,  -829,  -829,  -829,  -829,  -829,
    -829,   338,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  1338,  -829,   564,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,   768,   777,   565,   571,    75,   789,   626,    35,
     230,    75,  -829,  -829,   681,    75,   790,    75,   677,   792,
     678,    75,    75,    35,   807,   582,   788,   600,    35,   603,
      35,   250,  -829,  -829,   602,  -829,  -829,  -829,   354,  -829,
    -829,   854,   607,   608,  -829,  -829,  -829,   611,  -829,   613,
     808,  -829,  -829,  -829,   615,   617,   618,    75,    75,   620,
     621,   623,  -829,  -829,   148,  -829,    17,  -829,  -829,  -829,
     570,  -829,  -829,  -829,    75,  -829,    75,  -829,  -829,  -829,
    -829,    75,  -829,   230,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,   275,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
     335,  -829,  -829,   888,  -829,  -829,  -829,  -829,   875,   876,
    -829,  1338,  -829,  -829,  -829,   230,  -829,  -829,   877,  -829,
    -829,   878,   878,   878,   878,   878,  -829,  -829,  -829,   631,
     633,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
     382,  -829,  -829,   712,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,    41,   634,   635,  -829,  -829,  -829,
     230,    75,  -829,  -829,  -829,  1088,  1356,  -829,  -829,   785,
    -829,  -829,  -829,  -829,   106,  -829,   645,  -829,  -829,  -829,
    -829,  -829,   832,   115,   138,   172,  -829,   564,   643,   891,
     104,  -829,  -829,  -829,   903,   896,  -829,  1529,  1529,  1529,
    1529,  1529,  1529,  1529,  1529,  1529,  -829,   653,  -829,  -829,
    -829,   596,   596,  -829,  -829,  -829,   892,  -829,   663,  -829,
    -829,  -829,  1506,    75,    75,  -829,  -829,   668,    35,    35,
     669,   670,   703,    75,   704,    75,   705,   230,    75,   706,
     708,   709,   710,    75,  -829,    75,  -829,   726,  -829,   727,
     728,   729,   760,  -829,  -829,    27,   764,   741,   230,   782,
    -829,   779,   787,  -829,  -829,   160,  -829,  -829,   780,   816,
    -829,  -829,  -829,   817,   818,  -829,  -829,  -829,    75,   366,
     379,   819,    75,   230,  -829,  -829,  -829,  -829,  -829,  -829,
      17,  -829,  -829,  -829,  1070,  -829,    -6,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  1048,  1049,  1051,  1052,  1062,  -829,
    -829,  -829,  1519,  -829,  -829,  -829,  1356,   642,  -829,  -829,
    -829,  -829,   404,  -829,  -829,   564,  -829,  -829,   564,   564,
     564,   899,  1074,   104,  -829,  -829,   815,   487,  -829,   564,
    -829,   650,  -829,   820,   821,  -829,   824,   829,  -829,  -829,
    -829,   830,  -829,   833,  -829,   840,   841,  -829,  -829,  -829,
    -829,   844,   846,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
      75,  -829,  -829,   338,  -829,  -829,   853,  -829,  -829,  -829,
    -829,  -829,  -829,   808,  -829,  -829,   848,  1118,  1118,  1118,
    1118,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,     8,  -829,  1117,  -829,  -829,   880,   564,
    -829,  -829,  -829,   564,   564,   870,   885,   881,   399,   557,
    -829,  1356,  -829,   922,   931,   958,  -829,   887,  -829,  1142,
     981,   230,  -829,  -829,  -829,  -829,    75,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,   228,  -829,     7,  -829,  -829,
     438,   207,  -829,   148,  -829,   890,   894,   900,   901,   564,
     344,   564,  -829,   195,  1386,    10,  -829,  1137,   316,  -829,
    1506,   902,   907,  -829,  -829,  -829,  -829,  -829,  -829,   889,
    -829,  -829,   914,  -829,  -829,  -829,    49,  -829,  -829,  -829,
      47,    75,    75,    75,   985,   140,   -15,  -829,  -829,   918,
      75,   311,  -829,   919,  -829,   148,   148,   148,   148,   371,
     904,   479,   893,  -829,  1072,    40,   564,   564,   450,   399,
    -829,  -829,  -829,  1206,   920,  -829,    35,    75,    35,  -829,
     929,  -829,  -829,  -829,    75,    75,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,   932,   642,  1063,  -829,
     933,   934,   930,   533,   622,   938,   939,   940,   943,  -829,
     948,    75,    35,    75,    75,    75,  1044,    75,   155,   258,
      19,  1002,    75,   992,  -829,  -829,   963,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,   967,   966,  1072,   642,   557,  -829,
    -829,  -829,   564,   564,   564,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,    75,  -829,    75,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,    35,  -829,   154,  -829,  -829,  -829,  -829,  -829,
      40,   990,  1013,  1036,     5,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,   970,   976,   978,   -38,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,   983,  -829,  -829
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -829,  -829,  -829,  -130,  -829,  -191,  -193,  -245,   717,  -829,
    -170,  -829,  -829,  -829,  -829,  -829,   525,  -829,  -829,  -829,
    -829,  1159,  -829,  -829,  -829,  -829,  -829,  -829,  -214,  -829,
    -829,  -829,  -829,  -829,  1031,  1160,  1076,  -829,  -829,  -829,
    -829,  -829,   497,  -454,  -829,  -829,  -829,  -829,   -88,  -829,
     549,   111,  -829,   554,  -760,   468,  -460,  -829,  -408,  -829,
    -829,  -829,  1073,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,   734,  -829,  -829,
    -829,  -829,  -571,   530,  -829,   954,   748,   995,  -829,   698,
    -829,  -829,  -767,   281,  -829,  -155,   545,  -151,  -829,  -149,
     684,  -829,   255,  -829,  -829,   197,   343,  -829,  -829,  -728,
    -829,  -100,   470,   -61,  -829,  -829,   368,   566,   429,  -828,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
      91,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,
    -829,  -829,  -829,  -829,  -829,  -829,  -829,  -829,  -756
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -314
static const yytype_int16 yytable[] =
{
     165,   315,   350,   425,   487,   454,   352,   434,   354,   836,
     689,   325,   685,   337,   741,   326,   381,   382,   383,   384,
     385,  1065,   449,   432,   433,   327,   308,   471,   879,   455,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   332,
     312,   537,   311,   312,   313,   702,   549,   313,   312,   612,
     613,   402,   313,   346,   347,   957,   754,   136,   734,   403,
     404,   405,   406,   428,   495,   518,   497,   403,   404,   405,
     406,   267,   893,   283,   438,     1,   268,    49,   346,   347,
     888,   142,   381,   382,   383,   384,   385,   340,   312,  1039,
     398,   456,   313,   479,   519,   345,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   469,   979,   125,   475,   476,
     918,   836,   381,   382,   383,   384,   385,   346,   347,   137,
     754,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   381,   382,   383,   384,   385,   280,
     946,   276,   429,   312,   932,    99,   277,   313,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   312,   312,   735,
     281,   313,   313,   284,   132,   980,   976,   550,   381,   382,
     383,   384,   385,  1005,   579,   580,   581,   635,   979,  1073,
     480,   481,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   381,   382,   383,   384,   385,   836,    50,   958,   698,
    1015,   959,   472,   473,   126,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   955,   332,   280,   332,  1074,   332,
     332,   422,   423,   127,    96,    51,   699,   651,   650,  1034,
      52,   790,  1040,    53,   128,  1041,   432,   433,   323,   836,
    1049,  1050,   662,   563,   130,   410,   309,   667,   134,   669,
     131,   947,   328,    54,    55,    97,    56,   589,   700,   329,
     894,   338,   880,    57,  1066,   288,   905,   948,   935,   944,
     602,   603,   604,   605,   703,   133,   411,   412,   836,   836,
     836,   314,   614,    58,   314,   135,   647,   706,   418,   314,
     138,   652,   489,    59,   348,   654,   269,   656,   441,   442,
     710,   660,   661,   104,   105,   945,   949,   166,   289,    60,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   348,
     631,   632,   633,   634,   865,   106,   937,   107,   108,   314,
     938,   606,   710,   689,    92,    93,   607,   693,   694,    96,
     490,   316,   642,   317,   318,   139,   272,   140,   141,   582,
     142,   143,   144,    61,   707,    94,   708,   275,   348,   145,
     146,   709,   147,   285,   148,   413,   745,   381,   382,   383,
     384,   385,   920,   491,   280,   748,   278,   738,   295,  1058,
    1059,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     610,   118,   302,   611,   314,   296,   615,   149,   749,   616,
     139,   178,   140,   141,   297,   142,   143,   144,   314,   314,
     674,   119,   670,   298,   145,   146,   120,   147,   800,   148,
     762,   179,   180,   794,   299,   181,   182,   111,   109,   184,
     185,   807,   750,   808,   492,   112,   113,   290,   291,   292,
     921,   739,   671,   672,   809,   350,   810,   766,   767,   755,
     300,   933,   149,   301,   775,   924,   354,   186,  1036,   304,
      62,   187,   114,   115,   116,   117,   922,   305,  1037,  1038,
     306,   150,   151,   307,   791,   381,   382,   383,   384,   385,
     445,   446,   152,   153,   154,   110,   903,   155,   762,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   462,   463,
     813,   322,   234,   763,   764,   333,   852,   969,   970,   971,
     972,   962,   587,   771,   588,   773,   590,   591,   776,   334,
      92,    93,   236,   781,   335,   782,   150,   151,   336,   381,
     382,   383,   384,   385,   713,   714,   751,   152,   153,   154,
     341,    94,   155,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   963,   964,   965,   966,   675,   342,   806,   343,
    -210,  -210,   812,  -210,   823,   139,   344,   140,   141,   868,
     142,   143,   144,   676,   399,   677,   432,   433,   705,   145,
     146,   678,   147,   395,   148,   401,   626,   396,   350,   985,
     986,   824,   397,   987,   715,   716,   901,   988,   156,  -313,
     100,   101,   627,   417,   228,   229,   157,   911,   628,   421,
     825,   419,   906,   393,   394,   629,   630,   149,   381,   382,
     383,   384,   385,   725,   726,   727,   728,   973,   876,   877,
     878,   230,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   731,   732,   912,   913,   914,   420,   915,   424,   823,
     866,   426,   916,   156,   427,  -308,   432,   433,   851,   840,
     841,   157,   430,   826,   827,   828,   829,   830,   831,   832,
     599,   600,   431,   435,   436,   437,   824,   843,   844,   845,
     833,   169,  -210,   834,   439,   440,   170,   443,   850,   447,
     444,   150,   151,   450,   171,   825,   448,   917,   451,   452,
     453,   457,   152,   153,   154,   459,   460,   155,   381,   382,
     383,   384,   385,   461,   464,   468,   902,   465,   477,   172,
     470,   478,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   102,   103,   484,   482,   975,   122,   123,   124,   483,
     485,   488,   493,   494,   496,  1008,   498,  1010,   826,   827,
     828,   829,   830,   831,   832,   499,   500,   502,   883,   501,
     514,   504,   884,   885,   515,   833,   505,   890,   834,   516,
     350,   951,   952,   953,   517,   956,   522,   524,   593,   525,
     961,   381,   382,   383,   384,   385,   540,   546,   547,  1020,
     548,  1028,   562,   564,   584,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   585,   592,   597,  1009,   929,   608,
     931,  -210,   598,   643,  1012,  1013,  -210,   601,   156,   609,
     649,   645,   644,   648,   273,   274,   157,   646,   381,   382,
     383,   384,   385,   653,   173,   655,   657,   658,   664,   665,
     659,  1057,   386,   387,   388,   389,   390,   391,   392,   393,
     394,  1027,   663,  1029,  1030,  1031,   666,  1033,  1035,   668,
     673,   682,  1043,   683,   684,   983,   984,   686,   890,   687,
     174,   690,   234,   691,   692,   175,   695,   696,  1021,   697,
     357,   717,   718,   719,   722,   350,   723,   729,   357,   730,
     736,   176,  1055,   737,  1056,   381,   382,   383,   384,   385,
     746,  -210,   757,   752,  1060,   753,   756,   759,   760,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   381,   382,
     383,   384,   385,   762,   765,   768,   769,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     358,  1051,  1052,  1053,   381,   382,   383,   384,   385,   770,
     772,   774,   777,   793,   778,   779,   780,   733,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   381,   382,   383,
     384,   385,   783,   784,   785,   786,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   381,
     382,   383,   384,   385,   359,   360,   787,   361,   362,   363,
     364,   365,   792,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   381,   382,   383,   384,   385,   798,   797,   802,
     744,   816,   817,   799,   818,   819,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   820,   366,   367,   368,   369,
     370,   371,   372,   373,   366,   367,   368,   369,   370,   371,
     372,   373,   803,   804,   805,   849,   855,   847,   811,   823,
     857,   856,   374,   375,   376,   858,   859,   747,   168,   860,
     374,   375,   376,   178,   177,   178,   861,   862,   192,   191,
     863,   218,   864,   227,   873,   232,   824,   248,   254,   255,
     256,   869,   257,   179,   180,   179,   180,   181,   182,   181,
     182,   184,   185,   184,   185,   825,   874,   881,   193,   886,
     194,   506,   507,   508,   882,   377,   378,   889,   509,   510,
     178,   511,   898,   377,   378,   899,   925,   936,   941,   186,
     926,   186,   954,   187,   846,   187,   927,   928,   195,   974,
     179,   180,   939,   940,   181,   182,   196,   197,   184,   185,
     942,   287,   293,   294,   960,   968,  1007,   895,   826,   827,
     828,   829,   830,   831,   832,  1011,   896,  1014,  1016,  1019,
    1017,  1018,  1022,  1023,  1024,   833,   186,   198,   834,  1025,
     187,   565,   566,   567,   568,   569,  1026,   570,   571,   572,
     573,  1032,  1042,   897,   199,   200,  1044,   201,   202,  1045,
     203,   204,   205,  1046,   206,  1047,  1070,   207,   208,   217,
     209,   223,  1071,   231,  1072,   244,   900,   251,   178,  1075,
     261,   266,   721,   210,   211,  1062,   271,   821,   212,   854,
     213,   416,   214,   814,   215,   178,   822,   178,   179,   180,
     815,   872,   181,   182,   577,   233,   184,   185,  1063,   720,
     234,   539,   262,   234,   743,   179,   180,   179,   180,   181,
     182,   181,   182,   184,   185,   184,   185,  1048,   848,   758,
     236,  1064,   235,   236,   186,  1061,   887,   989,   187,   930,
     263,   842,     0,     0,     0,   990,     0,   219,   178,     0,
       0,   186,   220,   186,   221,   187,     0,   187,     0,     0,
     249,     0,     0,   216,     0,   258,     0,     0,   179,   180,
     977,     0,   181,   182,     0,   183,   184,   185,     0,     0,
       0,     0,     0,   740,   523,   639,     0,     0,     0,     0,
       0,   541,   542,   543,   544,   545,     0,     0,     0,     0,
     526,     0,     0,     0,   186,     0,     0,     0,   187,     0,
     222,     0,     0,   432,   433,   991,     0,     0,     0,     0,
       0,     0,   381,   382,   383,   384,   385,     0,     0,     0,
       0,     0,     0,     0,     0,   527,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,     0,     0,   992,     0,
     993,   994,   995,   996,   997,   998,   528,     0,   999,   529,
    1000,  1001,     4,   237,  1002,   530,   531,     0,     0,  1003,
       0,     0,     0,     5,     6,     0,     0,     0,     0,   532,
     533,   534,   535,     0,   536,     0,   238,   239,   240,   241,
       0,   565,   566,   567,   568,   569,   242,   570,   571,   572,
     573,     0,     0,     0,     0,  1004,     0,     0,   243,   565,
     566,   567,   568,   569,     0,   570,   571,   572,   573,     7,
       0,     0,     8,     0,     9,   250,     0,   264,     0,    10,
       0,     0,     0,     0,    11,    12,    13,    14,     0,     0,
       0,     0,   381,   382,   383,   384,   385,     0,     0,     0,
     934,     0,     0,     0,     0,   413,   386,   387,   388,   389,
     390,   391,   392,   393,   394,  -314,  -314,  -314,  -314,  -314,
       0,     0,     0,     0,     0,     0,     0,     0,   188,  -314,
    -314,  -314,  -314,  -314,   391,   392,   393,   394,   551,   552,
     553,   554,   555,   556,   557,   558,   559
};

static const yytype_int16 yycheck[] =
{
      61,   131,   157,   194,   249,   219,   157,   200,   157,   737,
     470,    13,   466,    13,   585,    17,     6,     7,     8,     9,
      10,    16,   213,    16,    17,    27,    38,    70,    20,   220,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   139,
      13,   286,   130,    13,    17,    28,    16,    17,    13,    25,
      26,   181,    17,    13,    14,    70,    16,    18,    17,    32,
      33,    34,    35,   104,   255,    71,   257,    32,    33,    34,
      35,    33,   839,     3,   204,     4,    38,     0,    13,    14,
     836,    16,     6,     7,     8,     9,    10,   148,    13,    70,
     178,   221,    17,   161,   100,   156,    20,    21,    22,    23,
      24,    25,    26,    27,    28,   235,   934,    17,   238,   239,
     870,   839,     6,     7,     8,     9,    10,    13,    14,    80,
      16,     6,     7,     8,     9,    10,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    20,    21,    22,    23,    24,
      25,    26,    27,    28,     6,     7,     8,     9,    10,    17,
     103,    33,   193,    13,   882,     3,    38,    17,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    13,    13,   128,
      38,    17,    17,   103,    17,   135,   932,   307,     6,     7,
       8,     9,    10,   943,    91,    92,    93,   401,  1016,   227,
     258,   259,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     6,     7,     8,     9,    10,   934,     3,   223,    61,
     977,   226,   255,   256,    18,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    84,   325,    17,   327,   266,   329,
     330,   178,   179,    37,    18,    31,    88,   430,   429,    84,
      36,   214,   223,    39,    48,   226,    16,    17,   137,   977,
    1017,  1018,   443,   314,    80,    38,   268,   448,    17,   450,
      86,   214,   264,    59,    60,    49,    62,   328,   120,   271,
     841,   271,   264,    69,   269,    66,   269,   230,   268,   230,
     341,   342,   343,   344,   267,    61,    69,    70,  1016,  1017,
    1018,   264,   268,    89,   264,    90,   426,   490,   187,   264,
      17,   431,   121,    99,   264,   435,   268,   437,   182,   183,
     503,   441,   442,    80,    81,   266,   269,    17,   109,   115,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   264,
     391,   392,   393,   394,   788,   102,    20,   104,   105,   264,
      24,   265,   535,   803,    17,    18,   270,   477,   478,    18,
     169,    13,   413,    15,    16,    11,     3,    13,    14,   266,
      16,    17,    18,   159,   494,    38,   496,     3,   264,    25,
      26,   501,    28,     3,    30,   158,   270,     6,     7,     8,
       9,    10,   175,   202,    17,   270,   268,   580,     3,   235,
     236,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     270,    13,    13,   273,   264,     3,   270,    63,   270,   273,
      11,    39,    13,    14,     3,    16,    17,    18,   264,   264,
      66,    33,   172,     3,    25,    26,    38,    28,   268,    30,
     270,    59,    60,   678,     3,    63,    64,    72,   205,    67,
      68,    75,   270,    77,   263,    80,    81,   238,   239,   240,
     243,   581,   202,   203,    75,   610,    77,   648,   649,   610,
       3,   266,    63,     3,   657,   873,   615,    95,   210,     3,
     266,    99,   107,   108,   109,   110,   269,     3,   220,   221,
       3,   137,   138,    20,   675,     6,     7,     8,     9,    10,
     191,   192,   148,   149,   150,   262,   268,   153,   270,    20,
      21,    22,    23,    24,    25,    26,    27,    28,   244,   245,
     703,   266,    74,   643,   644,    28,   761,   925,   926,   927,
     928,   210,   325,   653,   327,   655,   329,   330,   658,   264,
      17,    18,    94,   663,   157,   665,   137,   138,   157,     6,
       7,     8,     9,    10,   269,   270,   607,   148,   149,   150,
     264,    38,   153,    20,    21,    22,    23,    24,    25,    26,
      27,    28,   251,   252,   253,   254,   212,   264,   698,   264,
      13,    14,   702,    16,    17,    11,   264,    13,    14,   793,
      16,    17,    18,   229,    17,   231,    16,    17,    18,    25,
      26,   237,    28,   268,    30,    61,   125,   268,   753,   149,
     150,    44,   268,   153,   269,   270,   851,   157,   264,   265,
      97,    98,   141,    18,   242,   243,   272,   179,   147,   268,
      63,   266,   867,    27,    28,   154,   155,    63,     6,     7,
       8,     9,    10,   542,   543,   544,   545,   266,   808,   809,
     810,   269,    20,    21,    22,    23,    24,    25,    26,    27,
      28,   269,   270,   215,   216,   217,   266,   219,    18,    17,
     790,   197,   224,   264,   180,   266,    16,    17,    18,   265,
     266,   272,    92,   116,   117,   118,   119,   120,   121,   122,
     337,   338,   162,    55,   165,    55,    44,   748,   749,   750,
     133,    52,   135,   136,   163,   171,    57,   175,   759,   191,
     177,   137,   138,   199,    65,    63,   195,   269,   201,   266,
     268,   266,   148,   149,   150,   269,   268,   153,     6,     7,
       8,     9,    10,    59,   266,    18,   856,   268,    55,    90,
     268,    55,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     7,     8,   268,   266,   266,    12,    13,    14,   266,
     268,   266,   266,    59,    55,   946,   266,   948,   116,   117,
     118,   119,   120,   121,   122,   266,   266,    18,   829,    55,
       3,   266,   833,   834,     3,   133,   266,   838,   136,     3,
     935,   911,   912,   913,     3,   915,     3,     3,    13,     3,
     920,     6,     7,     8,     9,    10,     3,     3,     3,   266,
       3,   992,   266,   266,   266,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   264,    12,    25,   947,   879,    13,
     881,   264,    26,    55,   954,   955,   269,    28,   264,    24,
     204,   266,    55,    44,   100,   101,   272,   266,     6,     7,
       8,     9,    10,   162,   205,    55,   169,    55,   266,    61,
     172,  1042,    20,    21,    22,    23,    24,    25,    26,    27,
      28,   991,    55,   993,   994,   995,   266,   997,   998,   266,
     268,    17,  1002,   266,   266,   936,   937,   266,   939,   266,
     241,   266,    74,   266,   266,   246,   266,   266,   266,   266,
       5,     3,    17,    17,    17,  1050,    18,   266,     5,   266,
     266,   262,  1032,   268,  1034,     6,     7,     8,     9,    10,
     265,   269,    16,   270,  1044,    24,    13,   264,    26,    20,
      21,    22,    23,    24,    25,    26,    27,    28,     6,     7,
       8,     9,    10,   270,   266,   266,   266,     6,     7,     8,
       9,    10,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      75,  1022,  1023,  1024,     6,     7,     8,     9,    10,   266,
     266,   266,   266,   232,   266,   266,   266,   265,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     6,     7,     8,
       9,    10,   266,   266,   266,   266,     6,     7,     8,     9,
      10,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      20,    21,    22,    23,    24,    25,    26,    27,    28,     6,
       7,     8,     9,    10,   139,   140,   266,   142,   143,   144,
     145,   146,   268,    20,    21,    22,    23,    24,    25,    26,
      27,    28,     6,     7,     8,     9,    10,   268,   266,   269,
     265,     3,     3,   266,     3,     3,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     3,   181,   182,   183,   184,
     185,   186,   187,   188,   181,   182,   183,   184,   185,   186,
     187,   188,   266,   266,   266,   270,   266,    13,   269,    17,
     266,   270,   207,   208,   209,   266,   266,   265,    67,   266,
     207,   208,   209,    39,    73,    39,   266,   266,    44,    78,
     266,    80,   266,    82,   266,    84,    44,    86,    52,    53,
      54,   268,    56,    59,    60,    59,    60,    63,    64,    63,
      64,    67,    68,    67,    68,    63,    18,    20,    74,   269,
      76,    71,    72,    73,   264,   260,   261,   266,    78,    79,
      39,    81,   265,   260,   261,    13,   266,    20,   269,    95,
     266,    95,   177,    99,   265,    99,   266,   266,   104,   265,
      59,    60,   270,   266,    63,    64,   112,   113,    67,    68,
     266,   108,   109,   110,   266,   266,   266,   265,   116,   117,
     118,   119,   120,   121,   122,   266,   265,   265,   135,   269,
     267,   267,   264,   264,   264,   133,    95,   143,   136,   266,
      99,   123,   124,   125,   126,   127,   268,   129,   130,   131,
     132,   177,   220,   265,   160,   161,   234,   163,   164,   266,
     166,   167,   168,   266,   170,   269,   266,   173,   174,    79,
     176,    81,   266,    83,   266,    85,   265,    87,    39,   266,
      90,    91,   535,   189,   190,   265,    97,   732,   194,   762,
     196,   185,   198,   714,   200,    39,   736,    39,    59,    60,
     716,   803,    63,    64,   320,    66,    67,    68,   265,   531,
      74,   286,    54,    74,   586,    59,    60,    59,    60,    63,
      64,    63,    64,    67,    68,    67,    68,  1016,   753,   615,
      94,   265,    93,    94,    95,  1050,   836,   939,    99,   880,
      82,   745,    -1,    -1,    -1,   109,    -1,   206,    39,    -1,
      -1,    95,   211,    95,   213,    99,    -1,    99,    -1,    -1,
     104,    -1,    -1,   269,    -1,   269,    -1,    -1,    59,    60,
     268,    -1,    63,    64,    -1,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,   265,   281,    17,    -1,    -1,    -1,    -1,
      -1,   288,   289,   290,   291,   292,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    95,    -1,    -1,    -1,    99,    -1,
     269,    -1,    -1,    16,    17,   179,    -1,    -1,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    -1,   212,    -1,
     214,   215,   216,   217,   218,   219,    59,    -1,   222,    62,
     224,   225,    39,   224,   228,    68,    69,    -1,    -1,   233,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    82,
      83,    84,    85,    -1,    87,    -1,   247,   248,   249,   250,
      -1,   123,   124,   125,   126,   127,   257,   129,   130,   131,
     132,    -1,    -1,    -1,    -1,   269,    -1,    -1,   269,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    96,
      -1,    -1,    99,    -1,   101,   269,    -1,   269,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,   158,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    39,    40,
      41,    42,    43,    44,    45,    46,    47
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   275,   276,    39,    50,    51,    96,    99,   101,
     106,   111,   112,   113,   114,   292,   293,   294,   333,   334,
     335,   337,   338,   339,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   353,   354,   355,   356,   357,   358,   359,
     360,   435,   436,   437,   438,   439,   440,   456,   458,     0,
       3,    31,    36,    39,    59,    60,    62,    69,    89,    99,
     115,   159,   266,   278,   286,   291,   296,   298,   301,   303,
     306,   307,   312,   318,   319,   362,   364,   374,   404,   405,
     406,   407,   441,   442,   443,   444,   452,   453,   457,   459,
     460,   461,    17,    18,    38,   361,    18,    49,   295,     3,
      97,    98,   361,   361,    80,    81,   102,   104,   105,   205,
     262,    72,    80,    81,   107,   108,   109,   110,    13,    33,
      38,   351,   361,   361,   361,    17,    18,    37,    48,   287,
      80,    86,    17,    61,    17,    90,    18,    80,    17,    11,
      13,    14,    16,    17,    18,    25,    26,    28,    30,    63,
     137,   138,   148,   149,   150,   153,   264,   272,   379,   383,
     388,   391,   392,   393,   395,   397,    17,   308,   308,    52,
      57,    65,    90,   205,   241,   246,   262,   308,    39,    59,
      60,    63,    64,    66,    67,    68,    95,    99,   269,   309,
     321,   308,    44,    74,    76,   104,   112,   113,   143,   160,
     161,   163,   164,   166,   167,   168,   170,   173,   174,   176,
     189,   190,   194,   196,   198,   200,   269,   309,   308,   206,
     211,   213,   269,   309,   408,   409,   410,   308,   242,   243,
     269,   309,   308,    66,    74,    93,    94,   224,   247,   248,
     249,   250,   257,   269,   309,   328,   330,   331,   308,   104,
     269,   309,   454,   455,    52,    53,    54,    56,   269,   297,
     300,   309,    54,    82,   269,   299,   309,    33,    38,   268,
     322,   295,     3,   361,   361,     3,    33,    38,   268,   325,
      17,    38,   336,     3,   103,     3,   340,   336,    66,   109,
     238,   239,   240,   336,   336,     3,     3,     3,     3,     3,
       3,     3,    13,   352,     3,     3,     3,    20,    38,   268,
     288,   322,    13,    17,   264,   277,    13,    15,    16,   302,
     363,   304,   266,   325,   375,    13,    17,    27,   264,   271,
     387,   389,   395,    28,   264,   157,   157,    13,   271,   390,
     397,   264,   264,   264,   264,   397,    13,    14,   264,   378,
     379,   380,   381,   382,   383,   384,   385,     5,    75,   139,
     140,   142,   143,   144,   145,   146,   181,   182,   183,   184,
     185,   186,   187,   188,   207,   208,   209,   260,   261,   396,
     462,     6,     7,     8,     9,    10,    20,    21,    22,    23,
      24,    25,    26,    27,    28,   268,   268,   268,   322,    17,
     311,    61,   277,    32,    33,    34,    35,   277,   279,   320,
      38,    69,    70,   158,   310,   371,   310,    18,   325,   266,
     266,   268,   178,   179,    18,   279,   197,   180,   104,   193,
      92,   162,    16,    17,   280,    55,   165,    55,   277,   163,
     171,   182,   183,   175,   177,   191,   192,   191,   195,   279,
     199,   201,   266,   268,   302,   279,   277,   266,   411,   269,
     268,    59,   244,   245,   266,   268,   450,   451,    18,   277,
     268,    70,   255,   256,   445,   277,   277,    55,    55,   161,
     258,   259,   266,   266,   268,   268,   280,   281,   266,   121,
     169,   202,   263,   266,    59,   279,    55,   279,   266,   266,
     266,    55,    18,   285,   266,   266,    71,    72,    73,    78,
      79,    81,   323,   324,     3,     3,     3,     3,    71,   100,
     326,   327,     3,   336,     3,     3,     3,    38,    59,    62,
      68,    69,    82,    83,    84,    85,    87,   281,   341,   371,
       3,   336,   336,   336,   336,   336,     3,     3,     3,    16,
     277,    39,    40,    41,    42,    43,    44,    45,    46,    47,
     289,   290,   266,   397,   266,   123,   124,   125,   126,   127,
     129,   130,   131,   132,   365,   366,   367,   369,   373,    91,
      92,    93,   266,   305,   266,   264,   372,   389,   389,   397,
     389,   389,    12,    13,   397,   401,   402,    25,    26,   390,
     390,    28,   397,   397,   397,   397,   265,   270,    13,    24,
     270,   273,    25,    26,   268,   270,   273,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   125,   141,   147,   154,
     155,   397,   397,   397,   397,   302,   313,   316,   317,    17,
     369,   370,   397,    55,    55,   266,   266,   277,    44,   204,
     279,   280,   277,   162,   277,    55,   277,   169,    55,   172,
     277,   277,   279,    55,   266,    61,   266,   279,   266,   279,
     172,   202,   203,   268,    66,   212,   229,   231,   237,   412,
     417,   420,    17,   266,   266,   317,   266,   266,   329,   330,
     266,   266,   266,   277,   277,   266,   266,   266,    61,    88,
     120,   332,    28,   267,   283,    18,   280,   277,   277,   277,
     280,   281,   282,   269,   270,   269,   270,     3,    17,    17,
     370,   282,    17,    18,   434,   434,   434,   434,   434,   266,
     266,   269,   270,   265,    17,   128,   266,   268,   280,   277,
     265,   366,   368,   373,   265,   270,   265,   265,   270,   270,
     270,   397,   270,    24,    16,   381,    13,    16,   384,   264,
      26,   315,   270,   277,   277,   266,   279,   279,   266,   266,
     266,   277,   266,   277,   266,   280,   277,   266,   266,   266,
     266,   277,   277,   266,   266,   266,   266,   266,   430,   433,
     214,   279,   268,   232,   281,   413,   414,   266,   268,   266,
     268,   449,   269,   266,   266,   266,   277,    75,    77,    75,
      77,   269,   277,   280,   324,   327,     3,     3,     3,     3,
       3,   290,   367,    17,    44,    63,   116,   117,   118,   119,
     120,   121,   122,   133,   136,   376,   393,   394,   398,   403,
     265,   266,   401,   397,   397,   397,   265,    13,   380,   270,
     397,    18,   281,   314,   316,   266,   270,   266,   266,   266,
     266,   266,   266,   266,   266,   317,   277,   422,   302,   268,
     418,   448,   329,   266,    18,   284,   284,   284,   284,    20,
     264,    20,   264,   397,   397,   397,   269,   396,   462,   266,
     397,   399,   400,   376,   366,   265,   265,   265,   265,    13,
     265,   281,   277,   268,   432,   269,   281,   423,   424,   425,
     415,   179,   215,   216,   217,   219,   224,   269,   328,   419,
     175,   243,   269,   447,   332,   266,   266,   266,   266,   397,
     402,   397,   393,   266,   134,   268,    20,    20,    24,   270,
     266,   269,   266,   431,   230,   266,   103,   214,   230,   269,
     416,   277,   277,   277,   177,    84,   277,    70,   223,   226,
     266,   277,   210,   251,   252,   253,   254,   446,   266,   332,
     332,   332,   332,   266,   265,   266,   462,   268,   377,   403,
     135,   381,   386,   397,   397,   149,   150,   153,   157,   400,
     109,   179,   212,   214,   215,   216,   217,   218,   219,   222,
     224,   225,   228,   233,   269,   328,   421,   266,   279,   277,
     279,   266,   277,   277,   265,   376,   135,   267,   267,   269,
     266,   266,   264,   264,   264,   266,   268,   277,   279,   277,
     277,   277,   177,   277,    84,   277,   210,   220,   221,    70,
     223,   226,   220,   277,   234,   266,   266,   269,   377,   376,
     376,   397,   397,   397,   426,   277,   277,   279,   235,   236,
     277,   386,   265,   265,   265,    16,   269,   427,   428,   429,
     266,   266,   266,   227,   266,   266
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 306 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 307 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 320 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 321 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 325 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 329 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 338 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 339 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 340 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 341 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 342 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 343 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 350 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 357 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 365 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 369 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 373 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 380 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 388 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 389 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 395 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 404 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 409 "cf-parse.y"
    { (yyval.g) = NULL; ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 410 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 414 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 415 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 419 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 420 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 424 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 425 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 426 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 427 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 428 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 429 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 430 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 431 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 432 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 438 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 439 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 453 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 456 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 459 "cf-parse.y"
    { cli_msg(7, "Shutdown requested"); order_shutdown(); ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 462 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 471 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 487 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 488 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 492 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 504 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 517 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 521 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 534 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 546 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 552 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 554 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 573 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 574 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 575 "cf-parse.y"
    { new_config->listen_bgp_flags |= SKF_V6ONLY; ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 582 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 594 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 600 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 608 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 612 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 613 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 614 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 615 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 616 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 617 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 618 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 619 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 623 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 625 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 626 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 630 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 638 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 639 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 647 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 655 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 656 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 657 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 661 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 662 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 679 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 694 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 709 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 710 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 711 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 716 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 720 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 721 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 722 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 723 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 724 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 725 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 731 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 732 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 733 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 738 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 742 "cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 743 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 764 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 782 "cf-parse.y"
    { ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 783 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 784 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 785 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 786 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 787 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 796 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 799 "cf-parse.y"
    { proto_show((yyvsp[(3) - (4)].s), 0); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 802 "cf-parse.y"
    { proto_show((yyvsp[(4) - (5)].s), 1); ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 806 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 810 "cf-parse.y"
    { if_show(); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 813 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 816 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 819 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 825 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 831 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 838 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 843 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 848 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 853 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 857 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 861 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 871 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 879 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 883 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 890 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 891 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 895 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 899 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 901 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 903 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 905 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 907 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 909 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 911 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 913 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 919 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 920 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 925 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 926 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 933 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_DISABLE); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 935 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_ENABLE); ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 937 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_RESTART); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 939 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_RELOAD); ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 941 "cf-parse.y"
    { proto_xxable((yyvsp[(3) - (4)].t), XX_RELOAD_IN); ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 943 "cf-parse.y"
    { proto_xxable((yyvsp[(3) - (4)].t), XX_RELOAD_OUT); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 947 "cf-parse.y"
    { proto_debug((yyvsp[(2) - (4)].t), 0, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 952 "cf-parse.y"
    { proto_debug((yyvsp[(2) - (4)].t), 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 956 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].s)->name; ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 957 "cf-parse.y"
    { (yyval.t) = "*"; ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 964 "cf-parse.y"
    { cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 964 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s) = cf_define_symbol((yyvsp[(2) - (4)].s), SYM_FILTER, (yyvsp[(4) - (4)].f));
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 973 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 977 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 978 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 979 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 980 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 981 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 982 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 983 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 984 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 985 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 986 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_IP:
	  case T_PAIR:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1005 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1016 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1017 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1024 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1025 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1032 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1041 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1049 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1073 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1074 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1078 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1084 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1087 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1097 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1098 "cf-parse.y"
    {
     if ((yyvsp[(1) - (2)].x)) {
       if ((yyvsp[(1) - (2)].x)->next)
	 bug("Command has next already set");
       (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x);
       (yyval.x) = (yyvsp[(1) - (2)].x);
     } else (yyval.x) = (yyvsp[(2) - (2)].x);
   ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1109 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1112 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1121 "cf-parse.y"
    { (yyval.i) = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1128 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1132 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1133 "cf-parse.y"
    { (yyval.v).type = T_PAIR; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1134 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1135 "cf-parse.y"
    {  (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1139 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1144 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1152 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1153 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1157 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1164 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1165 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1167 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1174 "cf-parse.y"
    { (yyval.trie) = f_new_trie(); trie_add_prefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1175 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_prefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1178 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1179 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(1) - (4)].e);
     (yyval.e)->data = (yyvsp[(3) - (4)].x);
     (yyval.e)->left = (yyvsp[(4) - (4)].e);
   ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1184 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1195 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1196 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1200 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1201 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1205 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1206 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1207 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1208 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1209 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1213 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1214 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1215 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1219 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1232 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1233 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1234 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1235 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1236 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1237 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1238 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1239 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1240 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1241 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1255 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1278 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1311 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1313 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1314 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1315 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1316 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1317 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1318 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1319 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1323 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1324 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1325 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1326 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1327 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1328 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1329 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1330 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1331 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1332 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1333 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1334 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1335 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1336 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1337 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1338 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1340 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1341 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1342 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1344 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1346 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1348 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1350 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1351 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1352 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1353 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1354 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1364 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1365 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1366 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1367 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1368 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1373 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1396 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1397 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1398 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1399 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1400 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1401 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1405 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1408 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1409 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1410 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1419 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1426 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1435 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1436 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1440 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1446 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 1456 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1465 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1471 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1476 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1483 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1488 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1494 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1495 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1496 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1505 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1506 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1507 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1508 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1514 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->default_local_pref = 100;
 ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1536 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1537 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1543 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1544 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1545 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1546 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1547 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1548 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1549 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1550 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (6)].i); BGP_CFG->multihop_via = (yyvsp[(5) - (6)].a); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1551 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1552 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1553 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1554 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1555 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1556 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1557 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1558 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1559 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1560 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1561 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 1562 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1563 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1564 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1565 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 1566 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1567 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1568 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 1569 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 1570 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1579 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1595 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 1596 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i) ; if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1600 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (3)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->vlink_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1621 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1622 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1635 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1649 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1650 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1651 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1655 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1665 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1666 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1667 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1668 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1669 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1670 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1671 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1672 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1673 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1678 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1699 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 1700 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 1701 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 1702 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 1703 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 1704 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 1705 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 1706 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 1707 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 1708 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 1709 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 1710 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 1711 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 1712 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 1714 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 1715 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 1716 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 1717 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1718 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 1719 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) cf_error("Buffer size is too small") ; ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1733 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 1742 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1761 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 1770 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 1780 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->strictnbma = 0;
  OSPF_PATT->stub = 0;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1813 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1818 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1823 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 1826 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 1829 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1832 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 1835 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 1838 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1843 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 1853 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 1858 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 1859 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1865 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 1874 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 1875 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 1876 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 1877 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 1878 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 1879 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 1881 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 1882 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 1883 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 1888 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 1889 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 1890 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 1895 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 1896 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 1897 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 1898 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 1899 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 1903 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 1904 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 1918 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 1934 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 1946 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&((struct static_config *) this_proto)->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 1955 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 1959 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&((struct static_config *) this_proto)->iface_routes, &this_srt->n);
   ;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 1965 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 1966 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 1967 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 1971 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 1979 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 1979 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 1984 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 1985 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 1986 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 1987 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 1988 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 1989 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1455 of yacc.c  */
#line 6523 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1992 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


